unit myutf8list;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface

uses
 Classes,lazutf8;

function SortItems(List:string;Separator:char):string;

type TListEnumerator=
object
 StringList:array of string;
 NrOfItems:integer;
 LastIndex:integer;
 procedure Init(List:string;Separators:string);
 function NextItem:string;
 function AnotherItem:boolean;
end;


implementation

procedure TListEnumerator.Init(List:string;Separators:string);
var
 i:integer;
 s:string;
begin
 NrOfItems:=0;
 LastIndex:=-1;
 if List<>'' then
 begin
  if UTF8Pos(List[UTF8Length(List)],Separators)=0 then
  List:=List+UTF8Copy(Separators,1,1);

  for i:=1 to UTF8Length(List) do
  if UTF8Pos(UTF8Copy(List,i,1),Separators)<>0 then
  inc(NrOfItems);

  setlength(StringList,NrOfItems);
  for i:=0 to NrOfItems-1 do
  begin
   s:='';
   while UTF8Pos(UTF8Copy(List,1,1),Separators)=0 do
   begin
    s:=s+UTF8Copy(List,1,1);
    UTF8Delete(List,1,1);
   end;
   StringList[i]:=s;
   UTF8Delete(List,1,1);
  end
 end
end;

function TListEnumerator.NextItem:string;
begin
 Result:='';
 if LastIndex<(NrOfItems-1) then
 begin
  inc(LastIndex);
  Result:=StringList[LastIndex];
 end
end;

function TListEnumerator.AnotherItem:boolean;
begin
 Result:=false;
 if LastIndex<(NrOfItems-1) then Result:=true
end;

function SortItems(List:string;Separator:char):string;
var
 L:TStringList;
 E:TListEnumerator;
 i:integer;
begin
 Result:='';
 if List<>'' then
 begin
  L:=TStringList.Create;
  L.Clear;
  E.Init(List,Separator);
  while E.AnotherItem do
  L.Add(E.NextItem);
  L.Sort;
  Result:='';
  for i:=0 to L.Count-1 do
  Result:=Result+L[i]+Separator;
  if length(Result)>0 then
  if UTF8Copy(Result,UTF8Length(Result),1)=Separator then
  UTF8Delete(Result,UTF8Length(Result),1);
  L.Free;
 end;
end;

end.
